Rem Midiplay.bas is the .mid player function for QB64 PD 2024.
Rem   v1.0a first release 05/02/2024
Rem   v1.1a new release 05/05/2024

' declare variables.
Dim SoundHandle As Long
Dim SoundVolume As Single

' enable midi support.
$Unstable:Midi
$MidiSoundFont:Default
'$MidiSoundFont:"silly.sf2"

' setup screen.
_Title "Midiplay"
_ScreenMove _Middle

' init volume
SoundVolume = 1!

' start midi interface.
Color 15
Print "Welcome to Midi player v1.1a."
Color 14
StartLoop:
'Print "Enter midi file";
'Input Midi$

Rem Call dialog v1.1a
Midi$ = _OpenFileDialog$("Open File", "", "*.mid", "Audio files", 0)

If Midi$ = "" Then Color 7: End
Midi$ = UCase$(Midi$)
If Right$(Midi$, 4) <> ".MID" Then
   Print "File not found."
   GoTo StartLoop
End If
If _FileExists(Midi$) = 0 Then
   Print "File not found."
   GoTo StartLoop
End If
If Right$(Midi$, 4) = ".MID" Then
   If _FileExists(Midi$) Then
      Color 15
      Print "  Enter <space>=pause/+plus 10/-minus 10/?=length."
      Print "  Press <escape> to exit, <enter> to restart."
      Color 14

      Rem Added v1.1a
      If _MessageBox("MidiPlay", "Load: " + Midi$, "yesno", "question") = 0 Then Color 7: End

      Print "Loading.."
      SoundHandle = _SndOpen(Midi$)
      If SoundHandle = 0 Then
         Print "File not found."
         GoTo StartLoop
      End If
      If SoundHandle Then
         Print "Playing.."
         _SndPlay SoundHandle
         Do
            _Limit 50
            x$ = InKey$
            If Len(x$) Then
               ' adjust volume control
               If x$ = Chr$(0) + Chr$(72) Then ' up
                  SoundVolume = SoundVolume + .1!
                  If SoundVolume > 1! Then SoundVolume = 1!
                  _SndVol SoundHandle, SoundVolume
               End If
               If x$ = Chr$(0) + Chr$(80) Then ' down
                  SoundVolume = SoundVolume - .1!
                  If SoundVolume < 0! Then SoundVolume = 0!
                  _SndVol SoundHandle, SoundVolume
               End If

               If x$ = Chr$(27) Then

                  Rem Added v1.1a
                  _MessageBox "MidiPlay", "Press <enter> to quit: ", "info"

                  _SndStop SoundHandle
                  _SndClose sooundhandle
                  Exit Do
               End If
               If x$ = Chr$(13) Then
                  _SndStop SoundHandle
                  _SndClose sooundhandle
                  GoTo StartLoop
               End If
               If x$ = "?" Then
                  S& = _SndLen(SoundHandle)
                  S$ = Str$(S&)
                  If InStr(S$, ".") Then
                     S$ = Left$(S$, InStr(S$, ".") + 2)
                  End If
                  Print "Handle"; SoundHandle; "length is"; S$; " seconds."
                  Print "Position is"; _SndGetPos(SoundHandle); "seconds. Volume is"; SoundVolume
               End If
               If x$ = "+" Or x$ = Chr$(0) + Chr$(77) Then ' right
                  z! = _SndGetPos(SoundHandle)
                  z! = z! + 10!
                  _SndSetPos SoundHandle, z!
                  S& = _SndGetPos(SoundHandle)
                  S$ = Str$(S&)
                  If InStr(S$, ".") Then
                     S$ = Left$(S$, InStr(S$, ".") + 2)
                  End If
                  Print "Position is"; S$; " seconds."
               End If
               If x$ = "-" Or x$ = Chr$(0) + Chr$(75) Then ' left
                  z! = _SndGetPos(SoundHandle)
                  z! = z! - 10!
                  If z! < 0! Then z! = 0!
                  _SndSetPos SoundHandle, z!
                  S& = _SndGetPos(SoundHandle)
                  S$ = Str$(S&)
                  If InStr(S$, ".") Then
                     S$ = Left$(S$, InStr(S$, ".") + 2)
                  End If
                  Print "Position is"; S$; " seconds."
               End If
               If x$ = Chr$(0) + Chr$(116) Then ' ctrl-right
                  z! = _SndGetPos(SoundHandle)
                  z! = z! + 30!
                  _SndSetPos SoundHandle, z!
                  S& = _SndGetPos(SoundHandle)
                  S$ = Str$(S&)
                  If InStr(S$, ".") Then
                     S$ = Left$(S$, InStr(S$, ".") + 2)
                  End If
                  Print "Position is"; S$; " seconds."
               End If
               If x$ = Chr$(0) + Chr$(115) Then ' ctrl-left
                  z! = _SndGetPos(SoundHandle)
                  z! = z! - 30!
                  If z! < 0! Then z! = 0!
                  _SndSetPos SoundHandle, z!
                  S& = _SndGetPos(SoundHandle)
                  S$ = Str$(S&)
                  If InStr(S$, ".") Then
                     S$ = Left$(S$, InStr(S$, ".") + 2)
                  End If
                  Print "Position is"; S$; " seconds."
               End If
               If x$ = " " Then
                  If _SndPaused(SoundHandle) Then
                     Print "Resume play."
                     _SndPlay SoundHandle
                  Else
                     Print "Pause play."
                     _SndPause (SoundHandle)
                  End If
               End If
            End If
         Loop
      End If
   End If
End If
Color 7
End

